/*************************************************************************
Author:   Bjoern Biesenbach <bjoern@bjoern-b.de
Date:     28.09.2006	
Hardware: any AVR - tested on ATmega8 and 2 DS18B20

Using code from Martin Thomas, Peter Dannegger and maybe others.
*************************************************************************/
#include <avr/io.h>
#include "dcf.h"

void dcf_action()
{
	switch(seconds_dcf)
	{
		case 21:	minutes_dcf[stat.minute]+=1;break;
		case 22:	minutes_dcf[stat.minute]+=2;break;
		case 23:	minutes_dcf[stat.minute]+=4;break;
		case 24:	minutes_dcf[stat.minute]+=8;break;
		case 25:	minutes_dcf[stat.minute]+=10;break;
		case 26:	minutes_dcf[stat.minute]+=20;break;
		case 27:	minutes_dcf[stat.minute]+=40;break;
		
		case 29:	hours_dcf[stat.minute]+=1;break;
		case 30:	hours_dcf[stat.minute]+=2;break;
		case 31:	hours_dcf[stat.minute]+=4;break;
		case 32:	hours_dcf[stat.minute]+=8;break;
		case 33:	hours_dcf[stat.minute]+=10;break;
		case 34:	hours_dcf[stat.minute]+=20;break;
		
		case 36:	day_dcf[stat.minute]+=1;break;
		case 37:	day_dcf[stat.minute]+=2;break;
		case 38:	day_dcf[stat.minute]+=4;break;
		case 39:	day_dcf[stat.minute]+=8;break;
		case 40:	day_dcf[stat.minute]+=10;break;
		case 41:	day_dcf[stat.minute]+=20;break;
		
		case 42:	weekday_dcf[stat.minute]+=1;break;
		case 43:	weekday_dcf[stat.minute]+=2;break;
		case 44:	weekday_dcf[stat.minute]+=4;break;
		
		case 45:	month_dcf[stat.minute]+=1;break;
		case 46:	month_dcf[stat.minute]+=2;break;
		case 47:	month_dcf[stat.minute]+=4;break;
		case 48:	month_dcf[stat.minute]+=8;break;
		case 49:	month_dcf[stat.minute]+=10;break;
		
		case 50:	year_dcf[stat.minute]+=1;break;
		case 51:	year_dcf[stat.minute]+=2;break;
		case 52:	year_dcf[stat.minute]+=4;break;
		case 53:	year_dcf[stat.minute]+=8;break;
		case 54:	year_dcf[stat.minute]+=10;break;
		case 55:	year_dcf[stat.minute]+=20;break;
		case 56:	year_dcf[stat.minute]+=40;break;
		case 57:	year_dcf[stat.minute]+=80;break;
	}
}		
void sync()
{
	if(minutes_dcf[0]==minutes_dcf[1]-1 &&
		hours_dcf[0]==hours_dcf[1] && 
		minutes_dcf[0]!=0 && hours_dcf[0]!=0)
	{
		minutes=minutes_dcf[1];
		hours=hours_dcf[0];
		seconds=seconds_dcf;
		stat.sync=1;
		clock_counter=0;
	}
	if(day_dcf[0]==day_dcf[1] && day_dcf[0]!=0)
		day=day_dcf[0];
	if(weekday_dcf[0]==weekday_dcf[1] && weekday_dcf[0]!=0)
		weekday=weekday_dcf[0]-1;
	if(month_dcf[0]==month_dcf[1] && month_dcf[0]!=0)
		month=month_dcf[0];
	if(year_dcf[0]==year_dcf[1] && year_dcf[0]!=0)
		year=year_dcf[0];
}	
void dcf()
{
	if(!bit_is_set(PINC,PC0))
	{
		dcf_counter++;
	}
	if(stat.dcf==0 && bit_is_set(PINC,PC0))
	{
		if(dcf_counter<dcf_schwelle)
		{
			dcf_action();
		}
		if(dcf_counter>dcf_neue_sek&&dcf_counter<200)
		{
			seconds_dcf=0;
			clock_counter_dcf=0;
			stat.minute = ~stat.minute;
			sync();
			if(stat.minute==0)
			{
				minutes_dcf[0]=0;
				minutes_dcf[1]=0;
				hours_dcf[1]=0;
				hours_dcf[0]=0;
				day_dcf[0]=0;
				day_dcf[1]=0;
				month_dcf[0]=0;
				month_dcf[1]=0;
				year_dcf[0]=0;
				year_dcf[1]=0;
				weekday_dcf[0]=0;
				weekday_dcf[1]=0;
			}
		}
		dcf_counter=0;
	}
	stat.dcf=bit_is_set(PINC,PC0);
}
