#ifndef __DCF_H__
#define __DCF_H__

#define dcf_schwelle 85
#define dcf_neue_sek 160

uint8_t seconds_dcf;
uint8_t dcf_counter;		// Zaehler der hundertstel Sekunden zwischen 
				// den Sekundenmarken beim DCF-Signal
				
uint8_t seconds_dcf;		// Interne DCF-Uhr: Sekunden
uint8_t minutes_dcf[2];		// Interne DCF-Uhr: Minuten (erste und zweite
				// Minute, zur Synchronisation wird verglichen)
uint8_t hours_dcf[2];		// Interne DCF-Uhr: Stunden (Array: siehe Min.)
uint8_t day_dcf[2];		// Interne DCF-Uhr: Tage (Array: siehe Min.)
uint8_t month_dcf[2];		// Interne DCF-Uhr: Monat (Array: siehe Min.)
uint8_t year_dcf[2];		// Interne DCF-Uhr: Jahr (Array: siehe Min.)
uint8_t weekday_dcf[2];		// Interne DCF-Uhr: Wochentag (Array: siehe Min.)

extern uint8_t clock_counter_dcf;
extern uint8_t clock_counter;
extern uint8_t seconds;		// Angezeigte Uhr: Sekunden
extern uint8_t minutes;		// Angezeigte Uhr: Minuten
extern uint8_t hours;		// Angezeigte Uhr: Stunden
extern uint8_t day;		// Angezeigte Uhr: Tage
extern uint8_t month;		// Angezeigte Uhr: Monat
extern uint8_t year;		// Angezeigte Uhr: Jahr
extern uint8_t weekday;		// Angezeigte Uhr: Wochentag

extern struct{
	unsigned char dcf:1;	// Status ob beim letzten IRQ DCF-Bit low oder 
				// high
	unsigned char sync:1;	// Interne Uhr mit DCF77 abgeglichen?
	unsigned char minute:1;	// Zum Vergleich ob empfangene Zeit korrekt
} stat;
void dcf();
#endif
