#include <avr/io.h>
#include "lcd_out.h"

char title[]="DCF77Clock by  DF1BB";	// Erste Zeile im Display
char weekdays[7][12]={"Montag","Dienstag","Mittwoch","Donnerstag","Freitag",
			"Samstag","Sonntag"};	// Array fuer die Wochentage

void printWeekday(uint8_t day)
{
	uint8_t wCounter;
	for(wCounter=0;wCounter<12;wCounter++)
	{
		if(weekdays[day][wCounter])
			lcd_data(weekdays[day][wCounter]);
		else
			lcd_data(' ');
	}
}

void printLcd()
{
	/*
	"DCF77Clock by  DF1BB"
	"      00:00:00      "
	"Donnerstag  XX.XX.XX"
	"IN:XXXX°C OUT:XXXX°C"
	*/
	uint8_t counter2=0;
	lcd_clear();
	while(title[counter2])
	{
		lcd_data(title[counter2]);
		counter2++;
	}
	printWeekday(weekday);
	lcdInt(day);
	lcd_data('.');
	lcdInt(month);
	lcd_data('.');
	lcdInt(year);
	for(counter2=0;counter2<6;counter2++)
	{
		lcd_data(' ');
	}
	lcdInt(hours);
	lcd_data(':');
	lcdInt(minutes);
	lcd_data(':');
	lcdInt(seconds);
	//lcdInt(stat.dcf);
	for(counter2=0;counter2<6;counter2++)
	{
		lcd_data(' ');
	}
	lcd_data('I');
	lcd_data('N');
	lcd_data(':');
	if(Subzero[0])
		lcd_data('-');
	else
		lcd_data(' ');
	lcdTemp(decicelsius[0]);
	lcd_data('C');
	lcd_data(' ');
	lcd_data('O');
	lcd_data('U');
	lcd_data('T');
	lcd_data(':');
	if(Subzero[1])
		lcd_data('-');
	else
		lcd_data(' ');
	lcdTemp(decicelsius[1]);
	lcd_data('C');
}
